c  Filter.f
c
c  this program reads in different energy holograms,
c  then convolutes them with a gaussian, in order to
c  remove high-frequency x(K') fringes associated with
c  atoms far away from the emitter, producing a low-
c  pass filtered x(K).  low-pass filtered x(K) is then
c  subtracted from the raw x(K) to obtain a high-pass
c  filtered x(K)
c
c  jul 95,	p. len
c  aug 95,	p. len (corrections)
c  sep 96,	p. len (finalized form)
c
c  initialization and parameterization
	real theta(45,180), phi(45,180), xK(30,45,180)
	real kx(30,45,180), ky(30,45,180), kz(30,45,180)
	real k(30), k0, kkx, kky, kkz
	integer ntheta, nphi
cccc	character*40 rawxK, lopassxK
	character*80 rawxK, hipassxK, lopassxK
	parameter(pi = 3.141592654)
	parameter(degtorad = pi/180.0)
	real ctheta(45,180)
c
c  read in reconstruction integration parameters
	open(unit = 10, file = 'GaussxK.in')
	  read(10,10) rawxK
	  read(10,*) ntheta
	  read(10,*) nphi	
cccc	  read(10,*) k0
cccc	  read(10,*) dk
	  read(10,*) nk
	  read(10,10) hipassxK
cccc	  read(10,10) lopassxK
	  read(10,*) sigma
cccc	  read(10,*) symmetry
	close(10)
10	format(a80)
c
c  initialize k
        do 90 ik = 1, nk
          k(ik) = k0 + (ik-1)*dk
90      continue
c
c  main read-in routine
	open(unit = 20, file = rawxK)
	do 100 ik = 1, nk
	  do 101 itheta = 1, ntheta
	    do 102 iphi = 1, nphi
	      read (20,*) k(ik), theta(itheta,iphi), phi(itheta,iphi), 
     &		   	 xK(ik,itheta,iphi)
102	      continue
101	    continue
100	continue
	close(20)
c
c  calculation of cos and sin functions.  All input angles are
c  now converted to radians.
        do 200 itheta = 1, ntheta
          do 201 iphi = 1, nphi
            ctheta(itheta,iphi) = cos(theta(itheta,iphi)*degtorad)
	    stheta = sin(theta(itheta,iphi)*degtorad)
	    cphi = cos(phi(itheta,iphi)*degtorad)
	    sphi = sin(phi(itheta,iphi)*degtorad)
	    do 202 ik = 1, nk
	      kx(ik,itheta,iphi) = k(ik)*ctheta(itheta,iphi)*cphi
	      ky(ik,itheta,iphi) = k(ik)*ctheta(itheta,iphi)*sphi
	      kz(ik,itheta,iphi) = k(ik)*stheta
202	    continue
201	  continue
200	continue
c
c  loop over each direction in x(K) 
	open (unit = 30, file = lopassxK)
	open (unit = 31, file = hipassxK)
	do 300 ik = 1, nk
 	  do 301 itheta = 1, ntheta
cccc 	    do 302 iphi = 1, symmetry
 	    do 302 iphi = 1, nphi
	      xKlo = 0.0
	      A = 0.0
c  integrate over all K' directions in x(K')
cccc	      do 303 jk = 1, nk
	jk = ik
	        do 304 jtheta = 1, ntheta
		  do 305 jphi = 1, nphi
c  find the Gaussian weighing function
	            kkx = (kx(ik,itheta,iphi) - kx(jk,jtheta,jphi))
     	            kky = (ky(ik,itheta,iphi) - ky(jk,jtheta,jphi))
     	            kkz = (kz(ik,itheta,iphi) - kz(jk,jtheta,jphi))
	            deltak2 = kkx*kkx + kky*kky + kkz*kkz
		    egauss = exp(-deltak2/(sigma*sigma))
	            xKlo = xKlo + 
     &	                   xK(jk,jtheta,jphi)*egauss*ctheta(jtheta,jphi)
	            A = A + egauss*ctheta(jtheta,jphi)
305		  continue
304	        continue
cccc303	      continue
	      xKlo = xKlo/A
	      xKhi = xK(ik,itheta,iphi) - xKlo
cccc	      write(30,3000) theta(itheta,iphi), phi(itheta,iphi), xKlo
	      write(31,3000) k(ik), theta(itheta,iphi), phi(itheta,iphi), xKhi
302	    continue
301	  continue
300	continue
cccc3000	format(2f6.1,2x,e14.7)
3000	format(3f6.1,2x,e14.7)
	close(30)
	close(31)
c
	stop
	end
