inputfile = OpenRead["raw:Ik"];
iKraw = ReadList[inputfile, {Number,Number,Number,Number}];
Close[inputfile];

stream1 = OpenAppend["normalized:xK",
FormatType -> OutputForm];

stream2 = OpenAppend["background:Io",
FormatType -> OutputForm];

unused = (1 + k + k^2 + k^3 + k^4 + k^5 + k^6)*
         (1 + Cos[theta Degree] + Cos[3*theta Degree] + Cos[5*theta Degree]
+
          Cos[7*theta Degree] + Cos[9*theta Degree] + Cos[11*theta Degree])

iK = Interpolation[iKraw];

io = Fit[iKraw, {1, k, Power[k, 2], Power[k, 3], Power[k, 4], Power[k, 5],

    Power[k, 6], Cos[Times[Degree, theta]],

    Times[k, Cos[Times[Degree, theta]]],

    Times[Power[k, 2], Cos[Times[Degree, theta]]],

    Times[Power[k, 3], Cos[Times[Degree, theta]]],

    Times[Power[k, 4], Cos[Times[Degree, theta]]],

    Times[Power[k, 5], Cos[Times[Degree, theta]]],

    Times[Power[k, 6], Cos[Times[Degree, theta]]],

    Cos[Times[3, Degree, theta]], Times[k, Cos[Times[3, Degree, theta]]],

    Times[Power[k, 2], Cos[Times[3, Degree, theta]]],

    Times[Power[k, 3], Cos[Times[3, Degree, theta]]],

    Times[Power[k, 4], Cos[Times[3, Degree, theta]]],

    Times[Power[k, 5], Cos[Times[3, Degree, theta]]],

    Times[Power[k, 6], Cos[Times[3, Degree, theta]]],

    Cos[Times[5, Degree, theta]], Times[k, Cos[Times[5, Degree, theta]]],

    Times[Power[k, 2], Cos[Times[5, Degree, theta]]],

    Times[Power[k, 3], Cos[Times[5, Degree, theta]]],

    Times[Power[k, 4], Cos[Times[5, Degree, theta]]],

    Times[Power[k, 5], Cos[Times[5, Degree, theta]]],

    Times[Power[k, 6], Cos[Times[5, Degree, theta]]],

    Cos[Times[7, Degree, theta]], Times[k, Cos[Times[7, Degree, theta]]],

    Times[Power[k, 2], Cos[Times[7, Degree, theta]]],

    Times[Power[k, 3], Cos[Times[7, Degree, theta]]],

    Times[Power[k, 4], Cos[Times[7, Degree, theta]]],

    Times[Power[k, 5], Cos[Times[7, Degree, theta]]],

    Times[Power[k, 6], Cos[Times[7, Degree, theta]]],

    Cos[Times[9, Degree, theta]], Times[k, Cos[Times[9, Degree, theta]]],

    Times[Power[k, 2], Cos[Times[9, Degree, theta]]],

    Times[Power[k, 3], Cos[Times[9, Degree, theta]]],

    Times[Power[k, 4], Cos[Times[9, Degree, theta]]],

    Times[Power[k, 5], Cos[Times[9, Degree, theta]]],

    Times[Power[k, 6], Cos[Times[9, Degree, theta]]],

    Cos[Times[11, Degree, theta]], Times[k, Cos[Times[11, Degree, theta]]],

    Times[Power[k, 2], Cos[Times[11, Degree, theta]]],

    Times[Power[k, 3], Cos[Times[11, Degree, theta]]],

    Times[Power[k, 4], Cos[Times[11, Degree, theta]]],

    Times[Power[k, 5], Cos[Times[11, Degree, theta]]],

    Times[Power[k, 6], Cos[Times[11, Degree, theta]]]},

{k,theta,phi}];

stream3 = OpenAppend["background:co-eff",
FormatType -> OutputForm];
      Write[stream3, io];

Do[
  Do[
    Do[
      xK = (iK[k,theta,phi] - N[io])/Abs[N[io]];
      Write[stream1, theta, "   ", phi, "   ", FortranForm[xK]];
      Write[stream2, theta, "   ", phi, "   ", FortranForm[N[io]]],
    {phi, 0, 355, 5}],
  {theta, 40, 85, 5}],
{k, 3.85, 7.45, 0.1}];

Close[stream1];
Close[stream2];
Exit
