c  Io-khat.f
c
c  fits a least squares line for I0 removal from scanned-energy data
c  sep 96	p. len	(final form)
c
	character*80 file_in, file_out
	real theta(30,120), phi(30,120)
	real xK(200,30,120)
	real xK1(200), xK0(200)
c
	open (unit = 10, file = 'Io.in')
	  read (10,1) file_in
	  read (10,*) ntheta
	  read (10,*) nphi
	  read (10,*) nk
	  read (10,1) file_out
	  read (10,*) sigma
	close (10)
1	format (a40)
c
	open (unit = 20, file = file_in)
	do 200 ik = 1, nk
	  do 200 itheta = 1, ntheta
	    do 200 iphi = 1, nphi
	      read (20,*) k(ik), theta(itheta,iphi), phi(itheta,iphi), 
     &	                  xK(ik,itheta,iphi)
200	continue
	close(20)
c
	do 300 itheta = 1, ntheta
	  do 300 iphi = 1, nphi
	    do 310 ik = 1, nk
	      xK1(ik) = xK(ik,itheta,iphi)
ccccc	      call calc_xK0(xK1, nk, xK0)
310	    continue
	    call calc_xK0(xK1, nk, xK0)
	    do 320 ik = 1, nk
	      xK(ik,itheta,iphi) = xK1(ik) - xK0(ik)
320	    continue
300	continue
c
	open (unit = 40, file = file_out)
	do 400 ik = 1, nk
	  do 400 itheta = 1, ntheta
	    do 400 iphi = 1, nphi
	      write (40,4) k(ik), theta(itheta,iphi), phi(itheta,iphi), 
     &	                      xK(ik,itheta,iphi)
400	continue
	close (40)
cccc4	format(2f6.1,2x,e14.7)
4	format(3f6.1,2x,e14.7)
	stop
	end
c
	subroutine calc_xK0(xK1, nk, xK0)
c
	real xK1(200), xK0(200), k(200)
c
	do 1000 ik = 1, nk
	  k(ik) = real(ik)
1000 	continue
c
	call lstsqr(k, xK1, nk, a, b)
c
	do 1100 ik = 1, nk
	  xK0(ik) = a*real(ik) + b
1100	continue
	return
	end
c
	subroutine lstsqr(x, y, n, a, b)
c
c  calculates the coefficients of the equation y = ax + b that best fits
c  the data supplied in the arrays x and y, using a least squares fit
c  t. m. r. ellis, _fortran 77 programming, 2nd ed._
c
	integer n
	real x(n), y(n), a, b
c
	integer i
	real xsum, ysum, xysum, x2sum
c
	xsum = 0.
	ysum = 0.
	xysum = 0.
	x2sum = 0.
c
	do 2000 i = 1, n
	  xsum = xsum + x(i)
	  ysum = ysum + y(i)
	  xysum = xysum + x(i)*y(i)
	  x2sum = x2sum + x(i)*x(i)
2000	continue
c
	a = (xsum*ysum - n*xysum)/(xsum*xsum - n*x2sum)
	b = (ysum - a*xsum)/n
	return
	end

