c  Io-khat.f
c
c  this program reads in different energy holograms,
c  then normalizes them with respect to each other
c
c  jul 95,	p. len
c  sep 96, 	p. len	(final form)
c
c  initialization and parameterization
	real theta(90,360), phi(90,360), xK(200,90,360)
cccc	real kx(10,90,360), ky(10,90,360), kz(10,90,360)
	real xK0(200), xK1(200)
	integer ntheta, nphi
	character*80 rawxK, normxK
	parameter(pi = 3.141592654)
	parameter(degtorad = pi/360.0)
	real ctheta(90,360)
c
c  read in reconstruction integration parameters
	open(unit = 10, file = 'Io.in')
	  read(10,10) rawxK
	  read(10,*) ntheta
	  read(10,*) nphi	
cccc	  read(10,*) k0
cccc	  read(10,*) dk
	  read(10,*) nk
	  read(10,10) normxK
	  read(10,*) sigma
	close(10)
10	format(a40)
c
c  main read-in routine
	open(unit = 20, file = rawxK)
	do 100 ik = 1, nk
	  do 101 itheta = 1, ntheta
	    do 102 iphi = 1, nphi
	      read (20,*) k(ik), theta(itheta,iphi), phi(itheta,iphi), 
     &		   	 xK(ik,itheta,iphi)
102	      continue
101	    continue
100	continue
	close(20)
c
c  calculation of cos and sin functions.  All input angles are
c  now converted to radians.
          do 201 itheta = 1, ntheta
            do 202 iphi = 1, nphi
              ctheta(itheta,iphi) = cos(theta(itheta,iphi)*degtorad)
202	    continue
201	  continue
c
	do 300 ik = 1, nk
	  xK0(ik) = 0.0
 	  do 301 itheta = 1, ntheta
 	    do 302 iphi = 1, nphi
	      xK0(ik) = xK0(ik) + xK(ik,itheta,iphi)*ctheta(itheta,iphi)
	      xK1(ik) = xK1(ik) + ctheta(itheta,iphi)
302	    continue
301	  continue
	write(*,*) ik, xK0(ik), xK1(ik), xK0(ik)/xK1(ik)
300	continue
c
	open (unit = 40, file = normxK)
cccc	open (unit = 50, file = 'test')
	do 400 ik = 1, nk
 	  do 401 itheta = 1, ntheta
 	    do 402 iphi = 1, nphi
	      write(40,4000) k(ik), theta(itheta,iphi), phi(itheta,iphi), 
     &	xK(ik,itheta,iphi)-(xK0(ik)/xK1(ik))
cccc	write(50,*) phi(itheta,iphi), xK(ik,itheta,iphi)-(xK0(ik)/xK1(ik))
402	    continue
401	  continue
400	continue
cccc4000	format(2f7.2,2x,e14.7)
4000	format(3f7.2,2x,e14.7)
c
	close(40)
	stop
	end

