From - Mon Jan 04 13:38:42 1999
Return-Path: <len@alohi.ucdavis.edu>
Received: from postal1.lbl.gov by electron. (SMI-8.6/SMI-SVR4)
	id PAA05661; Mon, 21 Dec 1998 15:01:09 -0800
Received: from SpamWall.lbl.gov (root@localhost [127.0.0.1])
	by postal1.lbl.gov (8.9.0/8.9.0) with ESMTP id PAA04037
	for <vanhove@electron.lbl.gov>; Mon, 21 Dec 1998 15:05:01 -0800 (PST)
Received: from alohi.ucdavis.edu (alohi.ucdavis.edu [169.237.42.53])
	by SpamWall.lbl.gov (8.9.0/8.9.0) with SMTP id PAA04023
	for <vanhove@lbl.gov>; Mon, 21 Dec 1998 15:05:00 -0800 (PST)
Received: by alohi.ucdavis.edu (4.1/SMI-4.1)
	id AA12048; Mon, 21 Dec 98 14:53:55 PST
Date: Mon, 21 Dec 98 14:53:55 PST
From: len@alohi.ucdavis.edu (Patrick Len)
Message-Id: <9812212253.AA12048@alohi.ucdavis.edu>
To: vanhove@lbl.gov
Subject: Xray-holo-p2.f
Content-Length: 5919


c  Xray-holo.f
c  xray hologram generator
c  may 92, s. thevuthasan
c  aug 92, p. len (comments and modifications)
c  aug 95, p. len (modification for energy scans)
c  sep 95, p. len (optimization for energy scans, 1 emitter only)
c  nov 95, p. len (addition of synchrotron polarization effects)
c  sep 96, p. len (finalized form)
c
        parameter (natmax = 500000, itypMx = 5, nemiMx = 20)
	parameter (pi = 3.141592653589793)	
	parameter (r0 = 2.8179409238e-05)
c
        real I, I0, imff, imf1, imf2, kr, krkr, xj(3), k0
	real k(30), theta(90), phi(360)
	complex amplitude1(30,90,360), amplitude2(30,90,360), e, ff 
        integer atmtyp(natmax), indxEm(nemiMx), nEmitr, numtyp  
        character*40 File_Ar, File_fk, File_xK
        real imf(30,0:180), ref(30,0:180), xjAtom(natmax,3)    
c
c  read in the input file
	open (unit = 10, file = 'Xray-holo.in')
	  read (10,*) File_Ar
	  read (10,*) File_fk
	  read (10,*) theta0
	  read (10,*) dtheta
	  read (10,*) ntheta
	  read (10,*) phi0
	  read (10,*) dphi
	  read (10,*) nphi
	  read (10,*) k0
	  read (10,*) dk
	  read (10,*) nk
	  read (10,*) File_xK
	close (10)
	backscatter = 1e6
c
c  initialization of theta, phi, and k arrays
        do 80 itheta = 1, ntheta
          theta(itheta) = theta0 + (itheta-1)*dtheta
	  theta(itheta) = theta(itheta)*pi/180.
80      continue
        do 90 iphi = 1, nphi
          phi(iphi) = phi0 + (iphi-1)*dphi
	  phi(iphi) = phi(iphi)*pi/180.
90      continue
        do 100 ik = 1, nk
          k(ik) = k0 + (ik-1)*dk
100	continue
c
c  read in the coordinate file
	open (unit = 20, file = File_Ar) 
	numtyp = 0
	nEmitr = 0 
	do 200 jatom = 1, natmax 
          read (20, *, end = 2) 
&              (xjAtom(jatom,ixyz),ixyz=1,3), isEmitr, atmtyp(jatom) 
	  numtyp = max0(atmtyp(jatom), numtyp)  
	  if (isEmitr .eq. 1) then 
   	    nEmitr = nEmitr + 1
   	    indxEm(nEmitr) = jatom 
	  endif 
200	continue  
2	close (20) 
	natoms = jatom - 1  
c
c  reading in the scattering factor file
        open (unit = 30, file = File_fk)  
	do 300 ik = 1, nk
          do 300 ithetark = 0, 180 
          read (30,*) dummy, ref(ik,ithetark), imf(ik,ithetark) 
300     continue  
	close (30)
c 
c  calculation of the k vector
cccc	hbar = 1.0545726663e-34
cccc	c = 2.99792458e08
cccc	eVmtoJA = 1e-10*1.6021773349e-19 
cccc	k = (energy*eVmtoJA)/(hbar*c)
c        
c  start of the hologram intensity calculations
	open (unit = 40, file = File_xK)
c
c  loop over theta	
        do 500 itheta = 1, ntheta
c
c  loop over phi
	  do 600 iphi = 1, nphi
c
c  loop over emitters
	    do 700 iemitr = 1, nEmitr
c
c  loop over atoms
	      do 800 jatom = 1, natoms
c
c  emitter can't scatter onto itself
                if (jatom .eq. indxEm(iemitr)) go to 800
c
c  coordinates for j'th atom, with emitter at origin
                do 900 jxyz = 1, 3
900               xj(jxyz) = xjAtom(jatom, jxyz) - 
&	                     xjAtom(indxEm(iemitr), jxyz)
                r = sqrt(xj(1)**2 + xj(2)**2 + xj(3)**2)
c
c  skip atoms that lie outside backscattering cut-off
	        if (xj(3) .lt. 0.0 .and. r .gt. backscatter) go to 800 
c
c  finding scattering angle
	thetark = aacos((xj(1)*cos(theta(itheta))*cos(phi(iphi)) +
     &			 xj(2)*cos(theta(itheta))*sin(phi(iphi)) + 
     &			 xj(3)*sin(theta(itheta))) / r) 
c
c  loop over energies
	        ithetark = int(thetark)
	        delta = abs(thetark - ithetark)
		do 1000 ik = 1, nk
c
c  calculate diffraction attenuation
                  kr = k(ik)*r
	          krkr = kr*(1. - cos(thetark))
	          e = cmplx(cos(krkr), sin(krkr))/kr
c
c  interpolation of scattering factor ff
c
	          ref1 = ref(ik,ithetark)
	          ref2 = ref(ik,ithetark + 1)
	          imf1 = imf(ik,ithetark)
	          imf2 = imf(ik,ithetark + 1)
c
	          reff = ref1 + (ref2 - ref1)*delta
	          imff = imf1 + (imf2 - imf1)*delta
c
	          ff = cmplx(reff, imff)
c
c  calculation of the scattered amplitude
	          call calc_polarization(xj,theta(itheta),phi(iphi),psi)
	          cpsi = cos(psi)
	          spsi = sin(psi)
	          amplitude1(ik,itheta,iphi) = amplitude1(ik,itheta,iphi) +
     &		      + e*ff*r0*cpsi*cpsi
	          amplitude2(ik,itheta,iphi) = amplitude2(ik,itheta,iphi) +
     &		      + e*ff*r0*spsi*cpsi
cccc     &		      + e*ff*r0*sqrt((1.0 + cos(thetark)**2)/2.0)
cccc	write(*,*) amplitude(ik,itheta,iphi),
cccc     &	e*ff*r0*sqrt((1.0 + cos(thetark)**2)/2.0),ik,itheta,iphi,jatom
c
c  end loop over energies
1000		continue
c
c  end loop over atoms
800           continue
c
c  end loop over emitters
700	    continue
c
c  end loop over phi 
600       continue
c
c  end loop over theta
500     continue
c
c  write loop
	I0 = 1.0
	do 2000 ik = 1, nk
	  do 2000 itheta = 1, ntheta
	    do 2000 iphi = 1, nphi
	      I = (cabs(amplitude1(ik,itheta,iphi) + 1.0))**2
     &		+ (cabs(amplitude2(ik,itheta,iphi)))**2
	      xK = (I - I0)/sqrt(I0)
cccc	      write (40,*) theta(itheta)*180./pi, phi(iphi)*180./pi, 
cccc     &	amplitude(ik,itheta,iphi)
	     write (40,4000) k(ik), theta(itheta)*180./pi, phi(iphi)*180./pi, xK
2000	continue
        close (40)
4000	format(4f7.2,2x,e14.7)
        end
c
	function aacos(costhetark)
c  allows for a small amount of roundoff error when cos(thetark) is
c  calculated as a dot product.
c
        if (abs(costhetark) .gt. 1.0001) stop 'Error 1 in aacos'
        if (abs(costhetark) .gt. 1) costhetark = sign(1.0, costhetark)
        aacos = acos(costhetark)
        return
	end
c
	subroutine calc_polarization(xj,theta,phi,psi)
c  calculates the effect of polarized incident synchrotron radiation
c
	real xj(3), theta, phi, opp, adj, psi
c
	ctheta = cos(theta)
	cphi = cos(phi)
	stheta = sin(theta)
	sphi = sin(phi)
c
	opp = -xj(1)*stheta*cphi - xj(2)*stheta*sphi - xj(3)*ctheta
	adj = xj(1)*ctheta*cphi + xj(2)*ctheta*sphi + xj(3)*stheta
c
	psi = atan2(opp,adj)
cccc	cpsi = cos(psi)
cccc	c2psi = cpsi*cpsi
c
	return
	end

